ConfigurableProvider (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.jcajce.provider.config

## Interface ConfigurableProvider

- All Known Implementing Classes:
    BouncyCastlePQCProvider, BouncyCastleProvider

      public interface ConfigurableProvider

  Implemented by the BC provider. This allows setting of hidden parameters, such as the ImplicitCA parameters from X.962, if used.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `DH_DEFAULT_PARAMS` Diffie-Hellman Default Parameters - VM wide version
    `static java.lang.String` | `EC_IMPLICITLY_CA` Elliptic Curve CA parameters - VM wide version
    `static java.lang.String` | `THREAD_LOCAL_DH_DEFAULT_PARAMS` Diffie-Hellman Default Parameters - thread local version
    `static java.lang.String` | `THREAD_LOCAL_EC_IMPLICITLY_CA` Elliptic Curve CA parameters - thread local version

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addAlgorithm(java.lang.String type, ASN1ObjectIdentifier oid, java.lang.String className)`
    `void` | `addAlgorithm(java.lang.String key, java.lang.String value)`
    `void` | `addKeyInfoConverter(ASN1ObjectIdentifier oid, AsymmetricKeyInfoConverter keyInfoConverter)`
    `boolean` | `hasAlgorithm(java.lang.String type, java.lang.String name)`
    `void` | `setParameter(java.lang.String parameterName, java.lang.Object parameter)`

- - ### Field Detail

    - #### THREAD_LOCAL_EC_IMPLICITLY_CA

          static final java.lang.String THREAD_LOCAL_EC_IMPLICITLY_CA

      Elliptic Curve CA parameters - thread local version
      See Also:
        Constant Field Values

    - #### EC_IMPLICITLY_CA

          static final java.lang.String EC_IMPLICITLY_CA

      Elliptic Curve CA parameters - VM wide version
      See Also:
        Constant Field Values

    - #### THREAD_LOCAL_DH_DEFAULT_PARAMS

          static final java.lang.String THREAD_LOCAL_DH_DEFAULT_PARAMS

      Diffie-Hellman Default Parameters - thread local version
      See Also:
        Constant Field Values

    - #### DH_DEFAULT_PARAMS

          static final java.lang.String DH_DEFAULT_PARAMS

      Diffie-Hellman Default Parameters - VM wide version
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### setParameter

          void setParameter(java.lang.String parameterName,
                          java.lang.Object parameter)

    - #### addAlgorithm

          void addAlgorithm(java.lang.String key,
                          java.lang.String value)

    - #### addAlgorithm

          void addAlgorithm(java.lang.String type,
                          ASN1ObjectIdentifier oid,
                          java.lang.String className)

    - #### hasAlgorithm

          boolean hasAlgorithm(java.lang.String type,
                             java.lang.String name)

    - #### addKeyInfoConverter

          void addKeyInfoConverter(ASN1ObjectIdentifier oid,
                                 AsymmetricKeyInfoConverter keyInfoConverter)